VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TerrainData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 1997-2012 Kei Sakamoto / Inui Tetsuyuki
' {vO̓t[\tgłAۏ؂łB
' {vOGNU General Public License(Ver.3܂͂ȍ~)߂̉
' ĔЕz܂͉ς邱Ƃł܂B

'n`f[^̃NX

'ʔԍ
Public ID As Integer
'
Public Name As String
'rbg}bv
Public Bitmap As String
'n`^Cv
Public Class As String
'ړRXg
Public MoveCost As Integer
'C
Public HitMod As Integer
'_[WC
Public DamageMod As Integer

'n`
Public colFeature As Collection


'NX̏
Private Sub Class_Initialize()
    ID = -1
End Sub

'NX̉
Private Sub Class_Terminate()
Dim i As Integer
    
    If Not colFeature Is Nothing Then
        With colFeature
            For i = 1 To .Count
                .Remove 1
            Next
        End With
        Set colFeature = Nothing
    End If
End Sub


'n`ʂǉ
Public Sub AddFeature(fdef As String)
Dim fd As FeatureData
Dim ftype As String, flevel As Double, fdata As String
Dim i As Integer, j As Integer
Dim buf As String
    
    If colFeature Is Nothing Then
        Set colFeature = New Collection
    End If
    
    buf = fdef
    
    'n`ʂ̎ށAxAf[^؂o
    flevel = DEFAULT_LEVEL
    i = InStr(buf, "Lv")
    j = InStr(buf, "=")
    If i > 0 And j > 0 And i > j Then
        i = 0
    End If
    If i > 0 Then
        ftype = Left$(buf, i - 1)
        If j > 0 Then
            flevel = CDbl(Mid$(buf, i + 2, j - (i + 2)))
            fdata = Mid$(buf, j + 1)
        Else
            flevel = CDbl(Mid$(buf, i + 2))
        End If
    ElseIf j > 0 Then
        ftype = Left$(buf, j - 1)
        fdata = Mid$(buf, j + 1)
    Else
        ftype = buf
    End If
    
    'n`ʂo^
    Set fd = New FeatureData
    With fd
        .Name = ftype
        .Level = flevel
        .StrData = fdata
    End With
    If IsFeatureAvailable(ftype) Then
        colFeature.Add fd, ftype & Format$(CountFeature)
    Else
        colFeature.Add fd, ftype
    End If
End Sub

'n`ʂ̑
Public Function CountFeature() As Integer
    If colFeature Is Nothing Then
        Exit Function
    End If
    CountFeature = colFeature.Count
End Function

'n`
Public Function Feature(Index As Variant) As String
Dim fd As FeatureData

    Set fd = colFeature.Item(Index)
    Feature = fd.Name
End Function

'n`ʂ̖
Public Function FeatureName(Index As Variant) As String
Dim fd As FeatureData

    Set fd = colFeature.Item(Index)
    With fd
        If Len(.StrData) > 0 Then
            FeatureName = ListIndex(.StrData, 1)
        ElseIf .Level <> DEFAULT_LEVEL Then
            FeatureName = .Name & "Lv" & Format$(.Level)
        Else
            FeatureName = .Name
        End If
    End With
End Function

'n`ʂ̃x
Public Function FeatureLevel(Index As Variant) As Double
Dim fd As FeatureData

    On Error GoTo ErrorHandler
    Set fd = colFeature.Item(Index)
    FeatureLevel = fd.Level
    If FeatureLevel = DEFAULT_LEVEL Then
        FeatureLevel = 1
    End If
    Exit Function

ErrorHandler:
    FeatureLevel = 0
End Function

'n`ʂ̃f[^
Public Function FeatureData(Index As Variant) As String
Dim fd As FeatureData

    On Error GoTo ErrorHandler
    Set fd = colFeature.Item(Index)
    FeatureData = fd.StrData
    Exit Function

ErrorHandler:
    FeatureData = ""
End Function

'w肵n`ʂĂ邩H
Public Function IsFeatureAvailable(fname As String) As Boolean
Dim fd As FeatureData

    If colFeature Is Nothing Then
        Exit Function
    End If
    For Each fd In colFeature
        If fd.Name = fname Then
            IsFeatureAvailable = True
            Exit Function
        End If
    Next
    IsFeatureAvailable = False
End Function

'w肵n`ʂ̓xw肪Ă邩H
Public Function IsFeatureLevelSpecified(Index As Variant) As Boolean
Dim fd As FeatureData
    
    On Error GoTo ErrorHandler
    Set fd = colFeature.Item(Index)
    
    If fd.Level = DEFAULT_LEVEL Then
        IsFeatureLevelSpecified = False
    Else
        IsFeatureLevelSpecified = True
    End If
    Exit Function

ErrorHandler:
    IsFeatureLevelSpecified = False
End Function

'f[^NA
Public Sub Clear()
Dim i As Integer
    
    ID = -1
    If Not colFeature Is Nothing Then
        With colFeature
            For i = 1 To .Count
                .Remove 1
            Next
        End With
        Set colFeature = Nothing
    End If
End Sub
