Attribute VB_Name = "FileDialog"
Option Explicit

' Copyright (C) 1997-2012 Kei Sakamoto / Inui Tetsuyuki
' {vO̓t[\tgłAۏ؂łB
' {vOGNU General Public License(Ver.3܂͂ȍ~)߂̉
' ĔЕz܂͉ς邱Ƃł܂B

'APIŃt@C_CAO邽߂̃W[

' OPENFILENAME\
Private Type OPENFILENAME
    lStructSize         As Long
    hwndOwner           As Long
    hInstance           As Long
    lpstrFilter         As String
    lpstrCustomFilter   As String
    nMaxCustFilter      As Long
    iFilterIndex        As Long
    lpstrFile           As String
    nMaxFile            As Long
    lpstrFileTitle      As String
    nMaxFileTitle       As Long
    lpstrInitialDir     As String
    lpstrTitle          As String
    flags               As Long
    nFileOffset         As Integer
    nFileExtension      As Integer
    lpstrDefExt         As String
    lCustData           As Long
    lpfnHook            As Long
    lpTemplateName      As String
End Type

'ut@CJṽ_CAO쐬
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" _
    (f As OPENFILENAME) As Long

'ut@Cۑṽ_CAO쐬
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" _
    (f As OPENFILENAME) As Long

't@C[hp̃_CAO\邽߂̊֐
Public Function LoadFileDialog(dtitle As String, _
    fpath As String, default_file As String, _
    ByVal default_filter As Integer, _
    ftype As String, fsuffix As String, _
    Optional ftype2 As String, Optional fsuffix2 As String, _
    Optional ftype3 As String, Optional fsuffix3 As String) As String
Dim f As OPENFILENAME
Dim fname As String, ftitle As String
Dim ret As Long
    
    fname = default_file & String$(1024 - Len(default_file), vbNullChar)
    ftitle = Space$(1024)
    
    ' OPENFILENAME\̂̏
    With f
        .hwndOwner = MainForm.hwnd
        If ftype3 <> "" Then
            .lpstrFilter = _
                "ׂĂ̧ (*.*)" & vbNullChar & "*.*" & vbNullChar _
                & ftype & " (*." & fsuffix & ")" & vbNullChar & "*." & fsuffix & vbNullChar _
                & ftype2 & " (*." & fsuffix2 & ")" & vbNullChar & "*." & fsuffix2 & vbNullChar _
                & ftype3 & " (*." & fsuffix3 & ")" & vbNullChar & "*." & fsuffix3 & vbNullChar
        ElseIf ftype2 <> "" Then
            .lpstrFilter = _
                "ׂĂ̧ (*.*)" & vbNullChar & "*.*" & vbNullChar _
                & ftype & " (*." & fsuffix & ")" & vbNullChar & "*." & fsuffix & vbNullChar _
                & ftype2 & " (*." & fsuffix2 & ")" & vbNullChar & "*." & fsuffix2 & vbNullChar
        Else
            .lpstrFilter = _
                "ׂĂ̧ (*.*)" & vbNullChar & "*.*" & vbNullChar _
                & ftype & " (*." & fsuffix & ")" & vbNullChar & "*." & fsuffix & vbNullChar
        End If
        .iFilterIndex = default_filter
        .lpstrFile = fname
        .nMaxFile = 1024
        .lpstrFileTitle = ftitle
        .nMaxFileTitle = 1024
        .lpstrInitialDir = fpath
        .lpstrTitle = dtitle
        .flags = &H201804
        .lpstrDefExt = ""
        .lStructSize = Len(f)
    End With
    
    ret = GetOpenFileName(f)
    
    Select Case ret
        Case 0
            'LZꂽ
            LoadFileDialog = ""
        Case 1
            't@CI
            LoadFileDialog = f.lpstrFile
            ' vbNullChar ܂łŐ؂oB
            LoadFileDialog = Left$(LoadFileDialog, InStr(LoadFileDialog, vbNullChar) - 1)
    End Select
End Function

't@CZ[up̃_CAO\邽߂̊֐
Public Function SaveFileDialog(dtitle As String, _
    fpath As String, default_file As String, _
    ByVal default_filter As Integer, _
    ftype As String, fsuffix As String, _
    Optional ftype2 As String, Optional fsuffix2 As String, _
    Optional ftype3 As String, Optional fsuffix3 As String) As String
Dim f As OPENFILENAME
Dim fname As String, ftitle As String
Dim ret As Long
    
    fname = default_file & String$(1024 - Len(default_file), vbNullChar)
    ftitle = Space$(1024)
    
    ' OPENFILENAME\̂̏
    With f
        .hwndOwner = MainForm.hwnd
        If ftype3 <> "" Then
            .lpstrFilter = _
                "ׂĂ̧ (*.*)" & vbNullChar & "*.*" & vbNullChar _
                & ftype & " (*." & fsuffix & ")" & vbNullChar & "*." & fsuffix & vbNullChar _
                & ftype2 & " (*." & fsuffix2 & ")" & vbNullChar & "*." & fsuffix2 & vbNullChar _
                & ftype3 & " (*." & fsuffix3 & ")" & vbNullChar & "*." & fsuffix2 & vbNullChar
        ElseIf ftype2 <> "" Then
            .lpstrFilter = _
                "ׂĂ̧ (*.*)" & vbNullChar & "*.*" & vbNullChar _
                & ftype & " (*." & fsuffix & ")" & vbNullChar & "*." & fsuffix & vbNullChar _
                & ftype2 & " (*." & fsuffix2 & ")" & vbNullChar & "*." & fsuffix2 & vbNullChar
        Else
            .lpstrFilter = _
                "ׂĂ̧ (*.*)" & vbNullChar & "*.*" & vbNullChar _
                & ftype & " (*." & fsuffix & ")" & vbNullChar & "*." & fsuffix & vbNullChar
        End If
        .iFilterIndex = default_filter
        .lpstrFile = fname
        .nMaxFile = 1024
        .lpstrFileTitle = ftitle
        .nMaxFileTitle = 1024
        .lpstrInitialDir = fpath
        .lpstrTitle = dtitle
        .flags = &H201804
        .lpstrDefExt = ""
        .lStructSize = Len(f)
    End With
    
    ret = GetSaveFileName(f)
    
    Select Case ret
        Case 0
            'LZꂽ
            SaveFileDialog = ""
        Case 1
            't@CI
            SaveFileDialog = f.lpstrFile
            ' vbNullChar ܂łŐ؂oB
            SaveFileDialog = Left$(SaveFileDialog, InStr(SaveFileDialog, vbNullChar) - 1)
    End Select
End Function

