VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "SpecialPowerDataList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 1997-2012 Kei Sakamoto / Inui Tetsuyuki
' {vO̓t[\tgłAۏ؂łB
' {vOGNU General Public License(Ver.3܂͂ȍ~)߂̉
' ĔЕz܂͉ς邱Ƃł܂B

'SXyVp[f[^Ǘ郊Xg̃NX

'XyVp[f[^̃RNV
Private colSpecialPowerDataList As New Collection


'NX̉
Private Sub Class_Terminate()
Dim i As Integer
    
    With colSpecialPowerDataList
        For i = 1 To .Count
            .Remove 1
        Next
    End With
    Set colSpecialPowerDataList = Nothing
End Sub

'XyVp[f[^XgɃf[^ǉ
Public Function Add(sname As String) As SpecialPowerData
Dim new_data As New SpecialPowerData

    new_data.Name = sname
    colSpecialPowerDataList.Add new_data, sname
    Set Add = new_data
End Function

'XyVp[f[^Xgɓo^Ăf[^̑
Public Function Count() As Integer
    Count = colSpecialPowerDataList.Count
End Function

'XyVp[f[^Xgw肵f[^폜
Public Sub Delete(Index As Variant)
    colSpecialPowerDataList.Remove Index
End Sub

'XyVp[f[^Xgw肵f[^o
Public Function Item(Index As Variant) As SpecialPowerData
    On Error GoTo ErrorHandler
    
    Set Item = colSpecialPowerDataList.Item(Index)
    Exit Function
    
ErrorHandler:
    Set Item = Nothing
End Function

'XyVp[f[^XgɎw肵f[^o^Ă邩H
Public Function IsDefined(Index As Variant) As Boolean
Dim dummy As SpecialPowerData

    On Error GoTo ErrorHandler
    Set dummy = colSpecialPowerDataList.Item(Index)
    IsDefined = True
    Exit Function
    
ErrorHandler:
    IsDefined = False
End Function

'f[^t@C fname f[^[h
Public Sub Load(fname As String)
Dim FileNumber As Integer
Dim ret As Integer, line_num As Long
Dim line_buf As String, buf As String, buf2 As String
Dim sd As SpecialPowerData
Dim data_name As String
Dim err_msg As String

    On Error GoTo ErrorHandler
    
    FileNumber = FreeFile
    Open fname For Input Access Read As #FileNumber
    
    line_num = 0
    
    Do While True
        data_name = ""
        
        Do
            If EOF(FileNumber) Then
                Close #FileNumber
                Exit Sub
            End If
            GetLine FileNumber, line_buf, line_num
        Loop While Len(line_buf) = 0
        
        '
        ret = InStr(line_buf, ",")
        If ret > 0 Then
            data_name = Trim$(Left$(line_buf, ret - 1))
            buf = Mid$(line_buf, ret + 1)
        Else
            data_name = line_buf
            buf = ""
        End If
        
        If InStr(data_name, " ") > 0 Then
            err_msg = "̂ɔpXy[X͎gpo܂B"
            Error 0
        End If
        If InStr(data_name, "i") > 0 Or InStr(data_name, "j") > 0 Then
            err_msg = "̂ɑSpʂ͎gpo܂B"
            Error 0
        End If
        If InStr(data_name, """") > 0 Then
            err_msg = "̂""͎gpo܂B"
            Error 0
        End If
        
        If IsDefined(data_name) Then
            Delete data_name
        End If
        Set sd = Add(data_name)
        
        With sd
            'ǂ݉
            ret = InStr(buf, ",")
            If ret > 0 Then
                err_msg = "ǂ݉̌ɗ]ȃf[^w肳Ă܂B"
                Error 0
            End If
            .KanaName = Trim$(buf)
            If .KanaName = "" Then
                .KanaName = StrToHiragana(data_name)
            End If
            
            'Zk`, ro, Ώ, ʎ, Kp, gp, Aj
            GetLine FileNumber, line_buf, line_num
            
            'Zk`
            ret = InStr(line_buf, ",")
            If ret = 0 Then
                err_msg = "roĂ܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(line_buf, ret - 1))
            buf = Mid$(line_buf, ret + 1)
            .ShortName = buf2
            
            'ro
            ret = InStr(buf, ",")
            If ret = 0 Then
                err_msg = "ΏۂĂ܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(buf, ret - 1))
            buf = Mid$(buf, ret + 1)
            If IsNumeric(buf2) Then
                .SPConsumption = CInt(buf2)
            Else
                DataErrorMessage "ro̐ݒ肪ԈĂ܂B", _
                    fname, line_num, line_buf, data_name
            End If
            
            'Ώ
            ret = InStr(buf, ",")
            If ret = 0 Then
                err_msg = "ʎԂĂ܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(buf, ret - 1))
            buf = Mid$(buf, ret + 1)
            If IsNumeric(buf2) Then
                err_msg = "ΏۂԈĂ܂B"
                Error 0
            End If
            .TargetType = buf2
            
            'ʎ
            ret = InStr(buf, ",")
            If ret = 0 Then
                err_msg = "ʎԂĂ܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(buf, ret - 1))
            buf = Mid$(buf, ret + 1)
            If IsNumeric(buf2) Then
                err_msg = "ʎԂԈĂ܂B"
                Error 0
            End If
            .Duration = buf2
            
            'Kp
            ret = InStr(buf, ",")
            If ret = 0 Then
                err_msg = "gpĂ܂B"
                Error 0
            End If
            buf2 = Trim$(Left$(buf, ret - 1))
            buf = Mid$(buf, ret + 1)
            If IsNumeric(buf2) Then
                err_msg = "KpԈĂ܂B"
                Error 0
            End If
            .NecessaryCondition = buf2
            
            'gp, Aj
            ret = InStr(buf, ",")
            If ret > 0 Then
                .Animation = Trim$(Mid$(buf, InStr(buf, ",") + 1))
            Else
                .Animation = .Name
            End If
            
            '
            GetLine FileNumber, line_buf, line_num
            If Len(line_buf) = 0 Then
                err_msg = "ʂw肳Ă܂B"
                Error 0
            End If
            .SetEffect line_buf
            
            '
            GetLine FileNumber, line_buf, line_num
            If Len(line_buf) = 0 Then
                err_msg = "w肳Ă܂B"
                Error 0
            End If
            .Comment = line_buf
        End With
    Loop
    
ErrorHandler:
    'G[
    If line_num = 0 Then
        ErrorMessage fname & "J܂B"
    Else
        Close #FileNumber
        DataErrorMessage err_msg, fname, line_num, line_buf, data_name
    End If
    TerminateSRC
End Sub

